<script>
  // Import
  import { scaleLinear, scaleOrdinal } from 'd3-scale';
  import { schemeDark2 } from 'd3-scale-chromatic';
  import { extent } from 'd3-array';

  // Dimensions
  const width = 800;
  const height = 100;
  const margin = { top: 20, right: 5, bottom: 5, left: 5 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  const radius = 5;

  // Array
  const values = [
    { x: 2, y: 1, category: "cat1" },
    { x: 4, y: 2, category: "cat3" },
    { x: 6, y: 1, category: "cat2" },
    { x: 7, y: 3, category: "cat3" },
    { x: 9, y: 1, category: "cat2" }
  ];

  const scaleX = scaleLinear().domain([0, 10]).range([0, innerWidth]);
  const scaleY = scaleLinear().domain([4, 0]).range([0, innerHeight]);
  
  const colorCategory = scaleOrdinal(schemeDark2).domain(extent(values.map(function (value) {
        return (value.category);})));
</script>

<svg viewBox="0 0 {width} {height}">
  <g transform="translate({margin.left},{margin.top})">
    <!--  -->
    <line x1=0 y1={innerHeight} 
    x2={innerWidth} y2={innerHeight} stroke="black"/>
    
    {#each values as value}
      <circle cx={scaleX(value.x)} cy={scaleY(value.y)} r={radius} fill={colorCategory(value.category)}/>
      <text x={scaleX(value.x)} y={scaleY(value.y) - 10} class="valueLabel"> {value.y} </text>
      <line x1={scaleX(value.x)} y1={scaleY(value.y) + radius}
            x2={scaleX(value.x)} y2={innerHeight} stroke="black"/>
    {/each}
  </g>
</svg>

<style>
  text {
    text-anchor: middle;
    font-size: small;
  }
</style>
